#include "Arduino.h"
#include <Servo.h>
#include "Common.h"

class Drucker
{ 
  private:
    int YcurPin = 0;
    int XcurPin = 0;
    int YPos = 0; // max: 1130
    int XPos = 0; // max: 1130
    int Xmax;
    int Ymax;
    bool grenzen = 1;
    bool extruderOn = 0;
    int pointsWrong[200][2];
    int pointnumberWrong = 0;
    double distY = 0;
    double distX = 0;
    
    int pin_X_01;
    int pin_X_02;
    int pin_X_03;
    int pin_X_04;
    
    int pin_Y_01;
    int pin_Y_02;
    int pin_Y_03;
    int pin_Y_04;
    
    int pin_X_Minus;
    int pin_Y_Minus;
    Servo extruder;
  
  
  public: 
    Drucker(int XmaxK, int YmaxK, int pin_X_01K,int pin_X_02K, int pin_X_03K, int pin_X_04K, int pin_Y_01K, int pin_Y_02K, int pin_Y_03K,int pin_Y_04K, int pin_extruderK, int pin_X_MinusK, int pin_Y_MinusK);
    Drucker();
    void drawLabyrinth(Point points[], int *pointnumber);
    void driveHome();
    void optimizeWay(int *pointnumber, Point points[]);
    void Yturn(double dist, bool dir);
    void Xturn(double dist, bool dir);
    void PrintEdge(int edge, double edgeLength);
    void extrude(bool extrude);
};
